## mingw-w64-qt6-declarative-6.6.3-1.src.tar.zst

=== src/qmldebug/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from qmldebug.pro.

#####################################################################
## QmlDebugPrivate Module:
#####################################################################

qt_internal_add_module(QmlDebugPrivate
    STATIC
    INTERNAL_MODULE
    SOURCES
        qqmldebugclient.cpp qqmldebugclient_p.h
        qqmldebugclient_p_p.h
        qqmldebugconnection.cpp qqmldebugconnection_p.h
        qqmldebugmessageclient.cpp qqmldebugmessageclient_p.h
        qqmldebugtranslationclient.cpp qqmldebugtranslationclient_p.h
        qqmlenginecontrolclient.cpp qqmlenginecontrolclient_p.h
        qqmlenginecontrolclient_p_p.h
        qqmlenginedebugclient.cpp qqmlenginedebugclient_p.h
        qqmlenginedebugclient_p_p.h
        qqmlinspectorclient.cpp qqmlinspectorclient_p.h
        qqmlinspectorclient_p_p.h
        qqmlpreviewclient.cpp qqmlpreviewclient_p.h
        qqmlpreviewclient_p_p.h
        qqmlprofilerclient.cpp qqmlprofilerclient_p.h
        qqmlprofilerclient_p_p.h
        qqmlprofilerclientdefinitions_p.h
        qqmlprofilerevent.cpp qqmlprofilerevent_p.h
        qqmlprofilereventlocation.cpp qqmlprofilereventlocation_p.h
        qqmlprofilereventreceiver.cpp qqmlprofilereventreceiver_p.h
        qqmlprofilereventtype.cpp qqmlprofilereventtype_p.h
        qqmlprofilertypedevent.cpp qqmlprofilertypedevent_p.h
        qv4debugclient.cpp qv4debugclient_p.h
        qv4debugclient_p_p.h
    PUBLIC_LIBRARIES
        Qt::CorePrivate
        Qt::Network
        Qt::PacketProtocolPrivate
        Qt::QmlPrivate
)

=== tools/qmlls/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## qmlls Tool:
#####################################################################

qt_internal_add_app(qmlls
    TARGET_DESCRIPTION "QML Language Server"
    SOURCES
        qmllanguageservertool.cpp
    DEFINES
        QT_USE_QSTRINGBUILDER
    LIBRARIES
        Qt::QmlLSPrivate
        Qt::QmlToolingSettingsPrivate
)
set_target_properties(qmlls PROPERTIES WIN32_EXECUTABLE FALSE)

=== examples/quickcontrols/flatstyle/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 3.16)
project(flatstyle LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)

if(NOT DEFINED INSTALL_EXAMPLESDIR)
    set(INSTALL_EXAMPLESDIR "examples")
endif()

set(INSTALL_EXAMPLEDIR "${INSTALL_EXAMPLESDIR}/quickcontrols/flatstyle")

find_package(Qt6 REQUIRED COMPONENTS Core Gui Quick QuickControls2 Widgets)

qt_add_executable(flatstyleexample WIN32 MACOSX_BUNDLE
    main.cpp
)

qt_add_qml_module(flatstyleexample
    URI flatstyle
    NO_RESOURCE_TARGET_PATH
    QML_FILES
        "MainForm.ui.qml"
        "flatstyle.qml"
        "imports/Flat/Button.qml"
        "imports/Flat/CheckBox.qml"
        "imports/Flat/Switch.qml"
        "imports/Theme/Theme.qml"
    RESOURCES
        "imports/Flat/qmldir"
        "imports/Theme/qmldir"
        "qtquickcontrols2.conf"
)

target_link_libraries(flatstyleexample PUBLIC
    Qt6::Core
    Qt6::Gui
    Qt6::Quick
    Qt6::QuickControls2
    Qt6::Widgets
)

install(TARGETS flatstyleexample
    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
)

=== examples/quickcontrols/gallery/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 3.16)
project(gallery_controls2 LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)

if(NOT DEFINED INSTALL_EXAMPLESDIR)
    set(INSTALL_EXAMPLESDIR "examples")
endif()

set(INSTALL_EXAMPLEDIR "${INSTALL_EXAMPLESDIR}/quickcontrols/gallery")

find_package(Qt6 REQUIRED COMPONENTS Core Gui Quick QuickControls2)

qt_add_executable(galleryexample WIN32 MACOSX_BUNDLE
    gallery.cpp
)

qt_add_qml_module(galleryexample
    URI gallery
    NO_RESOURCE_TARGET_PATH
    QML_FILES
        "+Material/ToolBar.qml"
        "ToolBar.qml"
        "gallery.qml"
        "pages/BusyIndicatorPage.qml"
        "pages/ButtonPage.qml"
        "pages/CheckBoxPage.qml"
        "pages/ComboBoxPage.qml"
        "pages/DelayButtonPage.qml"
        "pages/DelegatePage.qml"
        "pages/DialPage.qml"
        "pages/DialogPage.qml"
        "pages/FramePage.qml"
        "pages/GroupBoxPage.qml"
        "pages/PageIndicatorPage.qml"
        "pages/ProgressBarPage.qml"
        "pages/RadioButtonPage.qml"
        "pages/RangeSliderPage.qml"
        "pages/ScrollBarPage.qml"
        "pages/ScrollIndicatorPage.qml"
        "pages/ScrollablePage.qml"
        "pages/SliderPage.qml"
        "pages/SpinBoxPage.qml"
        "pages/StackViewPage.qml"
        "pages/SwipeViewPage.qml"
        "pages/SwitchPage.qml"
        "pages/TabBarPage.qml"
        "pages/TextAreaPage.qml"
        "pages/TextFieldPage.qml"
        "pages/ToolTipPage.qml"
        "pages/TumblerPage.qml"
    RESOURCES
        "icons/gallery/20x20/back.png"
        "icons/gallery/20x20/drawer.png"
        "icons/gallery/20x20/menu.png"
        "icons/gallery/20x20@2/back.png"
        "icons/gallery/20x20@2/drawer.png"
        "icons/gallery/20x20@2/menu.png"
        "icons/gallery/20x20@3/back.png"
        "icons/gallery/20x20@3/drawer.png"
        "icons/gallery/20x20@3/menu.png"
        "icons/gallery/20x20@4/back.png"
        "icons/gallery/20x20@4/drawer.png"
        "icons/gallery/20x20@4/menu.png"
        "icons/gallery/index.theme"
        "images/arrow.png"
        "images/arrow@2x.png"
        "images/arrow@3x.png"
        "images/arrow@4x.png"
        "images/arrows.png"
        "images/arrows@2x.png"
        "images/arrows@3x.png"
        "images/arrows@4x.png"
        "images/qt-logo.png"
        "images/qt-logo@2x.png"
        "images/qt-logo@3x.png"
        "images/qt-logo@4x.png"
        "qmldir"
        "qtquickcontrols2.conf"
)

target_link_libraries(galleryexample PUBLIC
    Qt6::Core
    Qt6::Gui
    Qt6::Quick
    Qt6::QuickControls2
)

if(UNIX AND NOT APPLE AND CMAKE_CROSSCOMPILING)
    find_package(Qt6 REQUIRED COMPONENTS QuickTemplates2)

    # Work around QTBUG-86533
    target_link_libraries(galleryexample PRIVATE Qt6::QuickTemplates2)
endif()

install(TARGETS galleryexample
    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
)

=== src/labs/wavefrontmesh/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_internal_add_qml_module(LabsWavefrontMesh
    URI "Qt.labs.wavefrontmesh"
    VERSION "${PROJECT_VERSION}"
    PLUGIN_TARGET qmlwavefrontmeshplugin
    CLASS_NAME QmlWavefrontMeshPlugin
    DEPENDENCIES
        QtQuick/auto
    SOURCES
        qwavefrontmesh.cpp qwavefrontmesh_p.h
        qqmlwavefrontmeshglobal_p.h
    DEFINES
        QT_BUILD_LABSWAVEFRONTMESH_LIB
    PUBLIC_LIBRARIES
        Qt::CorePrivate
        Qt::GuiPrivate
        Qt::QuickPrivate
    GENERATE_CPP_EXPORTS
    GENERATE_PRIVATE_CPP_EXPORTS
)

=== tests/benchmarks/quickcontrols/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from benchmarks.pro.

add_subdirectory(creationtime)
add_subdirectory(objectcount)

=== src/quickcontrols/basic/impl/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## qtquickcontrols2basicstyleimplplugin Plugin:
#####################################################################

qt_internal_add_qml_module(QuickControls2BasicStyleImpl
    URI "QtQuick.Controls.Basic.impl"
    VERSION "${PROJECT_VERSION}"
    CLASS_NAME QtQuickControls2BasicStyleImplPlugin
    PLUGIN_TARGET qtquickcontrols2basicstyleimplplugin
    SOURCES
        qquickbasicbusyindicator.cpp qquickbasicbusyindicator_p.h
        qquickbasicdial.cpp qquickbasicdial_p.h
        qquickbasicprogressbar.cpp qquickbasicprogressbar_p.h
    DEFINES
        QT_NO_CAST_FROM_ASCII
        QT_NO_CAST_TO_ASCII
    LIBRARIES
        Qt::CorePrivate
        Qt::Gui
        Qt::QmlPrivate
        Qt::QuickControls2ImplPrivate
        Qt::QuickPrivate
        Qt::QuickTemplates2Private
)

=== tests/auto/core/qqmlsettings/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if (NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_qqmlsettings LANGUAGES C CXX ASM)
    find_package(Qt6BuildInternals COMPONENTS STANDALONE_TEST)
endif()

# Collect test data
file(GLOB_RECURSE test_data_glob
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    data/*)
list(APPEND test_data ${test_data_glob})

qt_internal_add_test(tst_qqmlsettings
    SOURCES
        tst_qqmlsettings.cpp
    LIBRARIES
        Qt::Gui
        Qt::Qml
        Qt::QuickTestUtilsPrivate
    TESTDATA ${test_data}
)

qt_add_resources(tst_qqmlsettings "test_settings"
    PREFIX
        "/"
    FILES
        "test_settings.ini"
)

qt_internal_extend_target(tst_qqmlsettings CONDITION ANDROID OR IOS
    DEFINES
        QT_QMLTEST_DATADIR=":/data"
)

qt_internal_extend_target(tst_qqmlsettings CONDITION NOT ANDROID AND NOT IOS
    DEFINES
        QT_QMLTEST_DATADIR="${CMAKE_CURRENT_SOURCE_DIR}/data"
)

=== tests/auto/particles/qquickspritegoal/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from qquickspritegoal.pro.

#####################################################################
## tst_qquickspritegoal Test:
#####################################################################

# Collect test data
file(GLOB_RECURSE test_data_glob
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    data/* ../shared/*)
list(APPEND test_data ${test_data_glob})

qt_internal_add_test(tst_qquickspritegoal
    SOURCES
        tst_qquickspritegoal.cpp
    LIBRARIES
        Qt::CorePrivate
        Qt::Gui
        Qt::GuiPrivate
        Qt::QmlPrivate
        Qt::QuickParticlesPrivate
        Qt::QuickPrivate
        Qt::QuickTestUtilsPrivate
    TESTDATA ${test_data}
)

## Scopes:
#####################################################################

qt_internal_extend_target(tst_qquickspritegoal CONDITION ANDROID OR IOS
    DEFINES
        QT_QMLTEST_DATADIR=":/data"
)

qt_internal_extend_target(tst_qquickspritegoal CONDITION NOT ANDROID AND NOT IOS
    DEFINES
        QT_QMLTEST_DATADIR="${CMAKE_CURRENT_SOURCE_DIR}/data"
)

=== tests/auto/qml/qmlformat/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from qmlformat.pro.

#####################################################################
## tst_qmlformat Test:
#####################################################################

# Collect test data
file(GLOB_RECURSE test_data_glob
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    data/*)
list(APPEND test_data ${test_data_glob})

qt_internal_add_test(tst_qmlformat
    SOURCES
        tst_qmlformat.cpp
    DEFINES
        SRCDIR="${CMAKE_CURRENT_SOURCE_DIR}"
    LIBRARIES
        Qt::Core
        Qt::QmlDomPrivate
        Qt::TestPrivate
        Qt::QuickTestUtilsPrivate
    TESTDATA ${test_data}
    TIMEOUT 3000
)

add_dependencies(tst_qmlformat Qt::qmlformat)

## Scopes:
#####################################################################

qt_internal_extend_target(tst_qmlformat CONDITION ANDROID OR IOS
    DEFINES
        QT_QMLTEST_DATADIR=":/data"
)

qt_internal_extend_target(tst_qmlformat CONDITION NOT ANDROID AND NOT IOS
    DEFINES
        QT_QMLTEST_DATADIR="${CMAKE_CURRENT_SOURCE_DIR}/data"
)

=== tests/auto/qml/qmllint/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from qmllint.pro.

#####################################################################
## tst_qmllint Test:
#####################################################################

# Collect test data
file(GLOB_RECURSE test_data_glob
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    data/*)
list(APPEND test_data ${test_data_glob})

add_library(LintPlugin STATIC lintplugin.h lintplugin.cpp)
target_link_libraries(LintPlugin PRIVATE Qt::QmlCompilerPrivate)
qt_autogen_tools_initial_setup(LintPlugin)
target_compile_definitions(LintPlugin PRIVATE QT_STATICPLUGIN)

qt_internal_add_test(tst_qmllint
    SOURCES
        tst_qmllint.cpp
    LIBRARIES
        Qt::Gui
        Qt::QuickTestUtilsPrivate
        Qt::QmlCompilerPrivate
        LintPlugin
    TESTDATA ${test_data}
)

## Scopes:
#####################################################################

qt_internal_extend_target(tst_qmllint CONDITION ANDROID OR IOS
    DEFINES
        QT_QMLTEST_DATADIR=":/data"
)

qt_internal_extend_target(tst_qmllint CONDITION NOT ANDROID AND NOT IOS
    DEFINES
        QT_QMLTEST_DATADIR="${CMAKE_CURRENT_SOURCE_DIR}/data"
)

if (TARGET qmllint)
    add_dependencies(tst_qmllint Qt::qmllint)
endif()

if (TARGET qmljsrootgen)
    qt_internal_extend_target(tst_qmllint
        DEFINES
            QT_QMLJSROOTGEN_PRESENT
    )

    add_dependencies(tst_qmllint Qt::qmljsrootgen)
endif()

=== tests/auto/qml/qqmlparser/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from qqmlparser.pro.

#####################################################################
## tst_qqmlparser Test:
#####################################################################

# Collect test data
file(GLOB_RECURSE test_data_glob
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    data/*)
list(APPEND test_data ${test_data_glob})

qt_internal_add_test(tst_qqmlparser
    SOURCES
        tst_qqmlparser.cpp
    DEFINES
        SRCDIR="${CMAKE_CURRENT_SOURCE_DIR}"
    LIBRARIES
        Qt::Gui
        Qt::QmlPrivate
        Qt::QuickTestUtilsPrivate
        Qt::QmlDomPrivate
    TESTDATA ${test_data}
)

## Scopes:
#####################################################################

qt_internal_extend_target(tst_qqmlparser CONDITION CMAKE_CROSSCOMPILING
    DEFINES
        QTEST_CROSS_COMPILED
)

qt_internal_extend_target(tst_qqmlparser CONDITION ANDROID OR IOS
    DEFINES
        QT_QMLTEST_DATADIR=":/data"
)

qt_internal_extend_target(tst_qqmlparser CONDITION NOT ANDROID AND NOT IOS
    DEFINES
        QT_QMLTEST_DATADIR="${CMAKE_CURRENT_SOURCE_DIR}/data"
)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=qt6-declarative
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-debug")
_qtver=6.6.3
pkgver=${_qtver/-/}
pkgrel=1
pkgdesc='Classes for QML and JavaScript languages (mingw-w64)'
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.qt.io'
msys2_repository_url="https://code.qt.io/cgit/qt/qtdeclarative.git"
msys2_references=(
  'archlinux: qt6-declarative'
  "cpe: cpe:/a:qt:qt"
)
license=('spdx:LGPL-3.0-only WITH Qt-GPL-exception-1.0 AND BSD-3-Clause AND GFDL-1.3-no-invariants-only AND GPL-2.0-only AND GPL-3.0-only')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-qt6-shadertools"
             "${MINGW_PACKAGE_PREFIX}-qt6-languageserver"
             "rsync")
_pkgfn="${_realname/6-/}-everywhere-src-${_qtver}"
source=("https://download.qt.io/official_releases/qt/${pkgver%.*}/${_qtver}/submodules/${_pkgfn}.tar.xz"
        001-appending-qt6-to-remove-qt5-conflict.patch)
sha256sums=('05207b2cfcf2ca74321165e81fc382ca289340d52de74ca2bad4c2b124a792f3'
            'b08b7a9cd263eaa2f09ec1b7718d79c253b4e30f3a1f47df6c89fa2e85d7659d')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd $srcdir/${_pkgfn}

  apply_patch_with_msg \
    001-appending-qt6-to-remove-qt5-conflict.patch
}

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    --log-level=STATUS \
    -GNinja \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DPython_EXECUTABLE=${MINGW_PREFIX}/bin/python \
    ../${_pkgfn}

  PATH=$PWD/bin:$PATH ${MINGW_PREFIX}/bin/cmake --build .
}

package_qt6-declarative() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base")
  optdepends=("${MINGW_PACKAGE_PREFIX}-qt6-shadertools"
              "${MINGW_PACKAGE_PREFIX}-qt6-languageserver")
  conflicts=("${MINGW_PACKAGE_PREFIX}-qt6-quickcontrols2")
  replaces=("${MINGW_PACKAGE_PREFIX}-qt6-quickcontrols2")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6")

  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  # Seperate debug-info files
  rsync -armR --remove-source-files --include="*/" --include="*.debug" --exclude="*" --prune-empty-dirs ${pkgdir}/.${MINGW_PREFIX} ${srcdir}/${MSYSTEM}-debug/

  install -d "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
  install -Dm644 $_pkgfn/LICENSES/* -t "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
}

package_qt6-declarative-debug() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base-debug"
           "${MINGW_PACKAGE_PREFIX}-${_realname}")
  conflicts=("${MINGW_PACKAGE_PREFIX}-qt6-quickcontrols2-debug")
  replaces=("${MINGW_PACKAGE_PREFIX}-qt6-quickcontrols2-debug")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6-debug")
  options=('!strip')

  cp -rf ${srcdir}/${MSYSTEM}-debug${MINGW_PREFIX} "${pkgdir}"/
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
